$INTERFACE UP1MX2                                             97/12/01
  $SUBST('UZCSET')
  $HELP
    TYPE OF EXTREMUM:
       0 - MINIMUM
       1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
$REM  $ADD(REAL,'\F')
  $ADD(REAL,'\$AF(2*$NC+1)')
$REM  $ADD(INTEGER,'\NC\KA\KAP\KC\KCP')
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ---------------------------
*     PENALTY FUNCTION DEFINITION
*     ---------------------------
*
$OPTION(CHDIR=CHPOM)
 $00  CALL UP1MX2(NC,KA,KAP,KC,KCP,$AF,F)
      GOTO ($80,$10,$20,$40,$50) ISB+1
 $10  CONTINUE
      $MTYPE=FMODF
      $SUBST('UZFMOD')
      $SUBST('UCSVF2')
      GO TO $00
 $20  CONTINUE
      $IF(GMODF='G')
        $MTYPE='G'
        $SUBST('UZFMOD')
        $SUBST('UCSVG2')
        GO TO $00
      $ELSEIF(FMODF='F')
        $HELP
          METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
          NUMERICAL COMPUTATION OF GRADIENT:
            0 - CONSTANT DIFFERENCE
            1 - EASY COMPARATIVE METHOD
            2 - STEWART'S METHOD.
        $CHECK(MCG,2,'0\1\2',3)
        $IF(MCG=0)
          $SUBST('UF0G$(CON)1')
        $ELSE
          $SUBST('UF0G$(CON)2')
        $ENDIF
        GOTO ($90,$30) ISB+1
 $30  CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $20
 $90  CONTINUE
        $SUBST('UCSVG2')
        GO TO $00
      $ENDIF
 $40  CONTINUE
      $IF(SAVC>-1)
        IF(LDC.GE.0) THEN
        FC=$CF(KC)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNF1')
        $IF(ISNC>0)
          $SUBST('UCSVF1')
        $ENDIF
        $SUBST('UCSVF2')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<0)
        $IF(NCL<NC)
          $MTYPE=FMODC
          $SUBST('UZCMOD')
          $IF(NORMC>0) $SUBST('UCNRF1')
          $IF(ISNC>0)
            $SUBST('UCSVF1')
          $ENDIF
          $SUBST('UCSVF2')
          $IF(FMODC<>'F')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $SUBST('UCSVG2')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $50  CONTINUE
      $IF(SAVC>0)
        IF(LDC.GE.1) THEN
        $SUBST('UCLNG1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNG1')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<1)
        $IF(NCL<NC)
          $IF(GMODC='G')
            $MTYPE='G'
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(NORMF>0) CALL UXVMUL($NF,$XN,$GC,$GC,1)
            $SUBST('UCSVG2')
            GOTO $00
          $ELSEIF(FMODC='F')
            $IF(ISNC>0)
              IF (LD.GE.0) FC=$CF(KC)
            $ENDIF
 $55  CONTINUE
            $SUBST('UC0G$(CON)1')
            GOTO ($70,$60) ISB+1
 $60  CONTINUE
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0)
              $SUBST('UCNRF1')
            $ENDIF
            GO TO $55
 $70  CONTINUE
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(NORMF>0) CALL UXVMUL($NF,$XN,$GC,$GC,1)
            $SUBST('UCSVG2')
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $80  CONTINUE
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ----------------------------------
*     END OF PENALTY FUNCTION DEFINITION
*     ----------------------------------
*
$OPTION(CHDIR=CHPOM)
      $ADD(INIT)
        NPXX='UP1MX2'
      $ENDADD
      $EXIT
