$INTERFACE UULVP2                                             02/12/01
  $XR='XR'
  $GR='GR'
  $SO='SO'
  $GG=G
  $IF(CONSTR='C') $GG=SO
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - VARIATIONALLY DERIVED PRECONVEX UPDATE
      6 - SPECIAL UPDATE FOR SSBC METHOD
  $CHECK(MET,1,'1\2\3\4\5\6',3)
  $HELP
    VALUE OF THE CORRECTION PARAMETER:
      MET2=1 - UNIT VALUE
      MET2=2 - BALANCING VALUE EQUAL TO THE PREVIOUS RELATIVE
               PARAMETER
      MET2=3 - VALUE DERIVED FROM THE GRADIENT DIFFERENCES
      MET2=4 - GEOMETRIC MEAN OF THE PREVIOUS VALUES
      MET2=5 - GEOMETRIC MEAN OF THE PREVIOUS RELATIVE PARAMETER
               AND THE RATIO ZET/(ZET+SIG)
      MET2=6 - RATIO ZET/(ZET+SIG)
      MET2=7 - RATIO SQRT(ZET)/(SQRT(ZET)+SQRT(SIG))
  $CHECK(MET2,6,'1\2\3\4\5\6\7',4)
  $ADD(REAL,'\$XM($NF*$MF)\$XR($MF)\$GR($MF)\$SO($NF)\$XO($NF)&
  \$GO($NF)')
$REM  $ADD(INTEGER,'\NF\MF\INF')
  CALL UULVP2(NF,NN,$XM,$XR,$GR,$S,$SO,$XO,$GO,R,PO,PAR,MET,MET2,MET3&
,MET5)
  $ADD(INIT)
    NUXX='UULVP2'
  $ENDADD
  $EXIT
