$INTERFACE UULBI3                                             98/12/01
  $U4='U4'
  $IF(MET<5) $U4=U3
  $IF(MET=7) $U4=U3
  $HELP
    SELECTION OF SELF SCALING:
      1 - SELF SCALING SUPPRESSED
      2 - INITIAL SELF SCALING
  $CHECK(MET1,2,'1\2',4)
  $HELP
    SELECTION OF THE LINE SEARCH MODEL:
      MET2=1 - QUADRATIC MODEL
      MET2=2 - BACKWARD TAYLOR EXPANSION (3 TERMS)
      MET2=3 - BACKWARD TAYLOR EXPANSION (4 TERMS)
      MET2=4 - HOMOGENEOUS MODEL
  $CHECK(MET2,1,'1\2\3\4',4)
  $HELP
    REALIZATION FORM:
      1 - STRATEGY THAT USES 6*MF*NF OPERATIONS
      2 - STRATEGY THAT USES 4*MF*NF OPERATIONS
  $CHECK(MET5,1,'1\2',4)
    $ADD(REAL,'\$XM(2*$NF*$MF)\$XR($MF*($MF+1))\$HR($MF*(2*$MF+1))&
    \$XO($NF)\$G($NF)\$GO($NF)\$U1(2*$MF)\$U2(2*$MF)\$U3(2*$MF)&
    \$U4($MF)')
$REM  $ADD(REAL,'\PAR3')
$REM  $ADD(INTEGER,'\NF\MF')
  CALL UULBI3(NF,MF,MX,$XM,$XR,$HR,$XO,$G,$GO,$U1,$U2,$U3,$U4,R,F,FO&
,P,PO,ETA3,PAR3,MET,MET1,MET2,MET5)
  $ADD(INIT)
    NUXX='UULBI3'
  $ENDADD
  $EXIT
